/* G-CTB GNU Contabilidad
 * Copyright (C) 2001 Branly Abendano, EPN Ingenieria Sistemas  
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public  
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of   
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "incl.h"
#include "TransaccionContable.h"
#include "TipoDiario.h"
 
gint FILA_ACTUAL_TRANSACCION_CONTABLE = 0;
GnomeDbGrid *GRID_TRANSACCION_CONTABLE;


GtkWidget* get_grid_Transacciones_Contables (gchar *widget_name, gchar *string1,
					     gchar *string2, gint int1, gint int2) 
{  
  	return gnome_db_grid_new(GDA_RECORDSET(GetListadoTotalDeTransaccionesContables()));
}

GtkWidget*
get_combo_TipoDiario_Transacciones_Contables (gchar *widget_name, gchar *string1,
					      gchar *string2, gint int1, gint int2) 
{  
  	return gnome_db_combo_new(GDA_RECORDSET(GetListadoNombresTiposDiarios()),0);
}

GtkWidget*
get_combo_CtaContable_Transacciones_Contables (gchar *widget_name, gchar *string1,
					       gchar *string2, gint int1, gint int2) {  
  	return gnome_db_combo_new(GDA_RECORDSET(GetListadoNombresDeCtasContables()),0);
}

void
on_btnBuscarCtaContable_clicked        (GtkButton       *button,
                                        gpointer         user_data)
{ 
   GtkWidget *frmBuscarCtaContable;
   gchar *CodigoCtaContable = NULL;

  	CodigoCtaContable = (gchar *)gtk_entry_get_text (GTK_ENTRY (GTK_OBJECT(txtCodigoCtaContableTransContable)));

  	frmBuscarCtaContable = create_frmBuscarCtaContable ();

  	gtk_entry_set_text(GTK_ENTRY (GTK_OBJECT(txtBuscarCodigoCtaContable)), CodigoCtaContable );

  	gtk_widget_show (frmBuscarCtaContable);
}

void
on_cmbTipoDiarioTransContables_realize
                                        (GtkWidget       *widget,
                                        gpointer         user_data)
{
   Gda_Recordset *grs;

  	grs = GetListadoNombresTiposDiarios();

  	gnome_db_combo_refresh(GTK_OBJECT(cmbTipoDiarioTransContables));
  	gnome_db_combo_set_recordset(GTK_OBJECT(cmbTipoDiarioTransContables),GDA_RECORDSET(grs),0);
}

void
on_grdTransaccionesTransContables_realize             (GtkWidget       *widget,
                                        gpointer         user_data)
{
   Gda_Recordset *grs;

  	grs = GetListadoTotalDeTransaccionesContables ();

  	gnome_db_grid_clear(GNOME_DB_GRID(grdTransaccionesTransContables));
  	gnome_db_grid_refresh(GNOME_DB_GRID(grdTransaccionesTransContables));

  	gnome_db_grid_set_recordset(GNOME_DB_GRID(grdTransaccionesTransContables),GDA_RECORDSET(grs));

  	GRID_TRANSACCION_CONTABLE = GNOME_DB_GRID(grdTransaccionesTransContables);

}   

void
on_grdTransaccionesTransContables_select_row         (GnomeDbGrid     *gnomedbgrid,
                                        gint             arg1,
                                        gpointer         user_data) 
{
   gchar *text;
    
    	FILA_ACTUAL_TRANSACCION_CONTABLE = arg1;

    	gnome_db_grid_show_row_numbers (gnomedbgrid);

    	gtk_clist_get_text(GTK_CLIST(gnomedbgrid->grid),arg1-1,0,&text);
    	gtk_entry_set_text(GTK_ENTRY (GTK_OBJECT(txtCodigoTransaccionTransContable)), text );

    	gtk_clist_get_text(GTK_CLIST(gnomedbgrid->grid),arg1-1,1,&text);
    	gtk_entry_set_text(GTK_ENTRY (GTK_OBJECT(txtCodigoCtaContableTransContables)), text );

    	gtk_clist_get_text(GTK_CLIST(gnomedbgrid->grid),arg1-1,3,&text);
    	gtk_entry_set_text(GTK_ENTRY (GTK_OBJECT(txtDescripcionTransContables)), text );
                                        
    	gtk_clist_get_text(GTK_CLIST(gnomedbgrid->grid),arg1-1,4,&text);
    	gtk_entry_set_text(GTK_ENTRY(GTK_OBJECT(txtDocumentoTransContables)), text );

    	gtk_clist_get_text(GTK_CLIST(gnomedbgrid->grid),arg1-1,5,&text); 
    	gtk_entry_set_text(GTK_ENTRY (GTK_COMBO (GTK_OBJECT(cmbTipoDiarioTransContables))->entry), text );

    	gtk_clist_get_text(GTK_CLIST(gnomedbgrid->grid),arg1-1,7,&text);
    	gtk_entry_set_text(GTK_ENTRY (GTK_OBJECT(txtValorTransContables)), text );
    
    	gtk_clist_get_text(GTK_CLIST(gnomedbgrid->grid),arg1-1,8,&text);
    	gtk_entry_set_text(GTK_ENTRY (GTK_OBJECT(txtFechaTransContables)), text );
}

void
on_btnNextTransContables_clicked       (GtkButton       *button,
                                        gpointer         user_data) 
{
    	gtk_clist_unselect_row(GTK_CLIST(GRID_TRANSACCION_CONTABLE->grid), FILA_ACTUAL_TRANSACCION_CONTABLE-1, 0);
    	gtk_clist_select_row(GTK_CLIST(GRID_TRANSACCION_CONTABLE->grid), FILA_ACTUAL_TRANSACCION_CONTABLE, 0);
}                                       

void
on_btnPriorTransContables_clicked      (GtkButton       *button,
                                        gpointer         user_data) 
{
    	gtk_clist_unselect_row(GTK_CLIST(GRID_TRANSACCION_CONTABLE->grid), FILA_ACTUAL_TRANSACCION_CONTABLE-1, 0);
    	gtk_clist_select_row(GTK_CLIST(GRID_TRANSACCION_CONTABLE->grid), FILA_ACTUAL_TRANSACCION_CONTABLE-2, 0);
}

void
on_btnLastTransContables_clicked      (GtkButton       *button,
                                        gpointer         user_data) 
{
    	gtk_clist_unselect_row(GTK_CLIST(GRID_TRANSACCION_CONTABLE->grid), FILA_ACTUAL_TRANSACCION_CONTABLE-1, 0);
    	FILA_ACTUAL_TRANSACCION_CONTABLE = GRID_TRANSACCION_CONTABLE->total_rows;

    	gtk_clist_select_row(GTK_CLIST(GRID_TRANSACCION_CONTABLE->grid), FILA_ACTUAL_TRANSACCION_CONTABLE-1, 0);
}

void
on_btnFirstTransContables_clicked      (GtkButton       *button,
                                        gpointer         user_data) 
{
    	gtk_clist_unselect_row(GTK_CLIST(GRID_TRANSACCION_CONTABLE->grid), FILA_ACTUAL_TRANSACCION_CONTABLE-1, 0);
    	gtk_clist_select_row(GTK_CLIST(GRID_TRANSACCION_CONTABLE->grid), 0, 0);
}   

void
on_btnActualizarTransContables_clicked
                                        (GtkButton       *button,
                                        gpointer         user_data)
{   
   gchar *ComprobanteTransaccion = NULL; 
   Gda_Recordset *grs;
                                        
        ComprobanteTransaccion = (gchar *)gtk_entry_get_text (GTK_ENTRY (GTK_OBJECT(txtDocumentoTransContables)));
	
	if (g_strncasecmp(ComprobanteTransaccion,"",0) == 0) {
         	grs = GetListadoTotalDeTransaccionesContables();
	} else {
		grs = GetListadoAsientoContable (ComprobanteTransaccion);
	}

        gnome_db_grid_clear(GNOME_DB_GRID(grdTransaccionesTransContables));
        gnome_db_grid_refresh(GNOME_DB_GRID(grdTransaccionesTransContables));

        gnome_db_grid_set_recordset(GNOME_DB_GRID(grdTransaccionesTransContables),GDA_RECORDSET(grs));
}

void
on_btnInsertTransContables_clicked       (GtkButton       *button,
                                        gpointer         user_data)
{                                       
   gchar *CodigoCtaContable = NULL;
   gchar *DescripcionTransaccion = NULL;
   gchar *ComprobanteTransaccion = NULL;
   gchar *NombreDiarioTransaccion = NULL;
   gchar *ValorTransaccion = NULL;      
   gchar *FechaTransaccion = NULL;
    
   Gda_Recordset *grs;
   gint rc;

        CodigoCtaContable = (gchar *)gtk_entry_get_text (GTK_ENTRY (GTK_OBJECT(txtCodigoCtaContableTransContables)));
        DescripcionTransaccion = (gchar *)gtk_entry_get_text (GTK_ENTRY (GTK_OBJECT(txtDescripcionTransContables)));
        ComprobanteTransaccion = (gchar *)gtk_entry_get_text (GTK_ENTRY (GTK_OBJECT(txtDocumentoTransContables)));
        NombreDiarioTransaccion = (gchar *)gnome_db_combo_get_string (GTK_OBJECT(cmbTipoDiarioTransContables));
        ValorTransaccion = (gchar *)gtk_entry_get_text (GTK_ENTRY (GTK_OBJECT(txtValorTransContables)));
        FechaTransaccion = (gchar *)gtk_entry_get_text (GTK_ENTRY (GTK_OBJECT(txtFechaTransContables)));

	rc = InsertNuevoTransaccionContable (CodigoCtaContable, DescripcionTransaccion,
                                             ComprobanteTransaccion, NombreDiarioTransaccion,
                                             ValorTransaccion, FechaTransaccion);
        
        if (rc != 0) {
                g_print("\nNo se ingreso este registro");
        } else {
		grs = GetListadoAsientoContable (ComprobanteTransaccion);
        
                gnome_db_grid_clear(GNOME_DB_GRID(grdTransaccionesTransContables));
                gnome_db_grid_refresh(GNOME_DB_GRID(grdTransaccionesTransContables));
        
                gnome_db_grid_set_recordset(GNOME_DB_GRID(grdTransaccionesTransContables),GDA_RECORDSET(grs));
        }
}


void
on_btnDeleteTransContables_clicked       (GtkButton       *button,
                                        gpointer         user_data)
{  
   gchar *CodigoTransaccionContable = NULL;
   gchar *ComprobanteTransaccion = NULL;
   
   Gda_Recordset *grs;   
   gint rc;
                
        CodigoTransaccionContable = (gchar *)gtk_entry_get_text (GTK_ENTRY (GTK_OBJECT(txtCodigoTransaccionTransContable)));
        ComprobanteTransaccion = (gchar *)gtk_entry_get_text (GTK_ENTRY (GTK_OBJECT(txtDocumentoTransContables)));
                                 
	rc = DeleteTransaccionContable (CodigoTransaccionContable);
                
        if (rc != 0) {
                g_print("\nNo se ingreso este registro");
        } else {
		grs = GetListadoAsientoContable (ComprobanteTransaccion);
        
                gnome_db_grid_clear(GNOME_DB_GRID(grdTransaccionesTransContables));
                gnome_db_grid_refresh(GNOME_DB_GRID(grdTransaccionesTransContables));
                
                gnome_db_grid_set_recordset(GNOME_DB_GRID(grdTransaccionesTransContables),GDA_RECORDSET(grs));
        }
}
        

void
on_btnGrabarTransContables_clicked       (GtkButton       *button,
                                        gpointer         user_data)
{
   gchar *ComprobanteTransaccion = NULL;
   gchar *CadenaDebe = NULL;
   gchar *CadenaHaber = NULL;
   gchar *CadenaTotal = NULL;
   gfloat TotalDebeAsientoContable = 0;
   gfloat TotalHaberAsientoContable = 0;
   gfloat TotalAsientoContable = 0;
   gint rc;

        ComprobanteTransaccion = (gchar *)gtk_entry_get_text (GTK_ENTRY (GTK_OBJECT(txtDocumentoTransContables)));

	TotalDebeAsientoContable  = ConsultarTotalDebeAsientoContable(ComprobanteTransaccion);        
	TotalHaberAsientoContable = ConsultarTotalHaberAsientoContable(ComprobanteTransaccion);        

	TotalAsientoContable = TotalDebeAsientoContable-TotalHaberAsientoContable;
	
	sprintf(CadenaDebe,"%f",TotalDebeAsientoContable);
	sprintf(CadenaHaber,"%f",TotalHaberAsientoContable);
	sprintf(CadenaTotal,"%f",TotalAsientoContable);

        gtk_entry_set_text(GTK_ENTRY (GTK_OBJECT(txtTotalDebeTransContables)),CadenaDebe);
        gtk_entry_set_text(GTK_ENTRY (GTK_OBJECT(txtTotalHaberTransContables)),CadenaHaber);
        gtk_entry_set_text(GTK_ENTRY (GTK_OBJECT(txtTotalSaldoTransContables)),CadenaTotal);

	if (TotalAsientoContable == 0) {
		rc = SetearAsientoCuandrado (ComprobanteTransaccion);

        	if (rc != 0) {
                	g_print("\nNo se ingreso este registro");
        	} else {
                	gtk_entry_set_text(GTK_ENTRY (GTK_OBJECT(txtCodigoTransaccionTransContable)),"");
                	gtk_entry_set_text(GTK_ENTRY (GTK_OBJECT(txtDocumentoTransContables)),"");
                	gtk_entry_set_text(GTK_ENTRY (GTK_OBJECT(txtCodigoCtaContableTransContables)),"");
                	gtk_entry_set_text(GTK_ENTRY (GTK_OBJECT(txtDescripcionTransContables)),"");
                	gtk_entry_set_text(GTK_ENTRY (GTK_OBJECT(txtValorTransContables)),"");
        	}
        
        	gtk_widget_grab_focus(txtCodigoTransaccionTransContable);
	}
	if (TotalAsientoContable!=0) {
        	g_print("\nEl Asiento no se encuentra Cuadrado");
	}
}

void
on_btnSalirTransContable_clicked                    (GtkButton       *button,
                                                  gpointer         user_data)
{
    	gtk_exit(0);
}

gboolean
on_txtDocumentoTransContables_focus_out_event
                                        (GtkWidget       *widget,
                                        GdkEventFocus   *event,
                                        gpointer         user_data)
{
   gchar *ComprobanteTransaccion = NULL;
   Gda_Recordset *grs;   

        ComprobanteTransaccion = (gchar *)gtk_entry_get_text (GTK_ENTRY (GTK_OBJECT(txtDocumentoTransContables)));
	
	grs = GetListadoAsientoContable (ComprobanteTransaccion);
        
        gnome_db_grid_clear(GNOME_DB_GRID(grdTransaccionesTransContables));
        gnome_db_grid_refresh(GNOME_DB_GRID(grdTransaccionesTransContables));
                
        gnome_db_grid_set_recordset(GNOME_DB_GRID(grdTransaccionesTransContables),GDA_RECORDSET(grs));

  return FALSE;
}

